# TODO: pps (BR: pps-tools-devel)
%define		nettle_ver	3.4

Summary:	An NTP client/server
Summary(pl.UTF-8):	Klient/serwer NTP
Name:		chrony
Version:	4.2
Release:	1
License:	GPL v2
Group:		Daemons
Source0:	http://download.tuxfamily.org/chrony/%{name}-%{version}.tar.gz
# Source0-md5:	07282f8e76a4399d6c17009bb6345614
Source1:	%{name}.conf
Source2:	%{name}.keys
Source3:	%{name}d.sysconfig
Source4:	%{name}d.init
Source5:	%{name}.logrotate
Patch0:		fix-seccomp-build.patch
Patch1:		conf.d.patch
URL:		http://chrony.tuxfamily.org/
BuildRequires:	asciidoc
BuildRequires:	bison
BuildRequires:	libcap-devel
BuildRequires:	libedit-devel
BuildRequires:	libseccomp-devel
# for hashing; can be also nss 3.x or libtomcrypt
BuildRequires:	nettle-devel >= %{nettle_ver}
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.453
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Provides:	group(ntp)
Provides:	ntpdaemon
Provides:	user(ntp)
Requires:	nettle >= %{nettle_ver}
Obsoletes:	ntpdaemon
Conflicts:	logrotate < 3.8.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/ntp

# assume gcc 3.4 has it
%if "%{cc_version}" >= "3.4"
%define		specflags	-pie -fpie
%endif

%description
A client/server for the Network Time Protocol, this program keeps your
computer's clock accurate. It was specially designed to support
systems with dial-up Internet connections, and also supports computers
in permanently connected environments.

%description -l pl.UTF-8
Klient/serwer protokołu NTP (Network Time Protocol), pozwalający
utrzymać zegar komputera dokładnym. Został zaprojektowany w
szczególności do obsłużenia systemów z wdzwanianym połączeniem do
Internetu, obsługuje także komputery na stałym łączu.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
# NOTE: It is not autoconf generated configre
CC="%{__cc}" \
CFLAGS="%{rpmcflags} -Wmissing-prototypes -Wall" \
CPPFLAGS="%{rpmcppflags}" \
./configure \
	--enable-debug \
	--enable-ntp-signd \
	--enable-scfilter \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--docdir=%{_docdir} \
	--with-ntp-era=$(date -d '1970-01-01 00:00:00+00:00' +'%s') \
	--with-hwclockfile=%{_sysconfdir}/adjtime \
	--with-sendmail=%{_sbindir}/sendmail

%{__make} getdate all docs \
	ADOC=asciidoc

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{sysconfig,logrotate.d,rc.d/init.d} \
	$RPM_BUILD_ROOT{%{_sysconfdir}/chrony.d,/var/{lib/ntp,log/chrony}}

%{__make} install install-docs \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} -r $RPM_BUILD_ROOT%{_docdir}

cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/chrony.conf
cp -a %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/keys
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/chronyd
cp -a %{SOURCE5} $RPM_BUILD_ROOT/etc/logrotate.d/chrony
install -p %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d/chronyd

touch $RPM_BUILD_ROOT%{_localstatedir}/lib/ntp/{drift,rtc}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 246 ntp
%useradd -u 246 -d %{_localstatedir}/lib/ntp -g ntp -c "NTP Daemon" ntp

%post
/sbin/chkconfig --add chronyd
%service chronyd restart

%preun
if [ "$1" = "0" ]; then
	%service chronyd stop
	/sbin/chkconfig --del chronyd
fi

%postun
if [ "$1" = "0" ]; then
	%userremove ntp
	%groupremove ntp
fi

%files
%defattr(644,root,root,755)
%doc NEWS README FAQ examples/* doc/{faq,installation}.html
%dir %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/chrony.conf
%attr(750,root,root) %dir %{_sysconfdir}/chrony.d
%attr(640,root,ntp) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/keys
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/chronyd
%config(noreplace) /etc/logrotate.d/chrony
%attr(754,root,root) /etc/rc.d/init.d/chronyd
%attr(755,root,root) %{_bindir}/chronyc
%attr(755,root,root) %{_sbindir}/chronyd
%{_mandir}/man1/chronyc.1*
%{_mandir}/man5/chrony.conf.5*
%{_mandir}/man8/chronyd.8*

%dir %attr(770,root,ntp) /var/lib/ntp
%attr(640,ntp,ntp) %ghost /var/lib/ntp/drift
%attr(640,ntp,ntp) %ghost /var/lib/ntp/rtc

%dir %attr(770,ntp,ntp) /var/log/chrony
%changelog
* Sun Jan 23 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/chrony.git;a=log;h=master

* Sat Jan 22 2022 Marcin Krol <hawk@tld-linux.org> c89c5fe
- updated to 4.2

* Thu Sep 23 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 34f2939
- Rel 2; parse /etc/ntp/chrony.d/*.conf by default. Don't fail if there are no files there.

* Sat Sep 18 2021 Marcin Krol <hawk@tld-linux.org> 3b8450f
- updated to 4.1

* Sat Sep 18 2021 Marcin Krol <hawk@tld-linux.org> 3dd8d6a
- added comments, use more sets of servers from pool.ntp.org

* Sat Sep 18 2021 Marcin Krol <hawk@tld-linux.org> b04b61a
- upstream fix for recent glibc

* Thu May 14 2020 Jakub Bogusz <qboosh@pld-linux.org> 0608c56
- switched from readline to libedit (chrony is GPL v2 only while readline is GPL v3+ now)
- release 6 (nettle soname change)

* Tue Apr 28 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 56bdbca
- rel 5; revert commit which breaks responses on some multihomed machines; https://www.mail-archive.com/chrony-dev@chrony.tuxfamily.org/msg02152.html

* Mon Apr 27 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 5e2590d
- rel 4; socket based authentication is gone for some time; enable optional (-d) debug logging

* Mon Apr 27 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> f619f0a
- rel 3; use few features from example upstream configs

* Thu Apr 23 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 518bb5e
- rel 2; glibc related fixes

* Thu Feb 06 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 0511365
- up to 3.5

* Thu Oct 17 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 74c1fd4
- release 4 (by relup.sh)

* Wed Jun 26 2019 Adam Gołębiowski <adamg@pld-linux.org> 21c6360
- release 3, rebuild against libnettle.so.6 (nettle-3.5)

* Fri Jul 27 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 917d712
- rel 2; force nettle >= 3.4 to avoid: /usr/sbin/chronyd: relocation error: /usr/sbin/chronyd: symbol nettle_get_hashes version NETTLE_6 not defined in file libnettle.so.6 with link time reference

* Sat Apr 07 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> e4df7b9
- up to 3.3

* Sat Oct 21 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 893d7c0
- up to 3.2

* Sun Apr 16 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 6c47f93
- Update to 3.1

* Thu Jan 26 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 180c6ac
- up to 3.0

* Tue Oct 18 2016 Jan Rękorajski <baggins@pld-linux.org> fa09cf9
- rebuild with readline 7.0
- release 2 (by relup.sh)

* Tue Aug 30 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 0cb82a4
- up to 2.4

